//+------------------------------------------------------------------+
//|                                                   FiboPiv_v1.mq4 |
//|                                                 Kalenzo & Naatha |
//|                                      bartlomiej.gorski@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "bartlomiej.gorski@gmail.com"

#property indicator_chart_window

extern int TF=PERIOD_D1;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("S11");
   ObjectDelete("S22");
   ObjectDelete("S33");
   ObjectDelete("S44");
   ObjectDelete("R11");
   ObjectDelete("R22");
   ObjectDelete("R33");
   ObjectDelete("R44");
   ObjectDelete("PIVOT1");
   ObjectDelete("Support 11");
   ObjectDelete("Support 22");
   ObjectDelete("Support 33");
   ObjectDelete("Support 44");
   ObjectDelete("Pivot level1");
   ObjectDelete("Resistance 11");
   ObjectDelete("Resistance 22");
   ObjectDelete("Resistance 33");
   ObjectDelete("Resistance 44");
   
   Comment(" ");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   
//----
double rates[1][6],yesterday_close,yesterday_high,yesterday_low;
ArrayCopyRates(rates, Symbol(), TF);

if(DayOfWeek() == 1)
{
   if(TimeDayOfWeek(iTime(Symbol(),TF,1)) == 5)
   {
       yesterday_close = rates[1][4];
       yesterday_high = rates[1][3];
       yesterday_low = rates[1][2];
       
   }
   else
   {
      for(int d = 5;d>=0;d--)
      {
         if(TimeDayOfWeek(iTime(Symbol(),TF,d)) == 5)
         {
             yesterday_close = rates[d][4];
             yesterday_high = rates[d][3];
             yesterday_low = rates[d][2];
             
         }
         
      }  
   }
}
else
{
    yesterday_close = rates[1][4];
    yesterday_high = rates[1][3];
    yesterday_low = rates[1][2];
    
}


//---- Calculate Pivots

Comment("\nLastCandle quotations:\nH ",yesterday_high,"\nL ",yesterday_low, "\nC ",yesterday_close);
double R = yesterday_high - yesterday_low;//range
double p = (yesterday_high + yesterday_low + yesterday_close)/3;// Standard Pivot
double R44 = p + (R * 1.618);
double R33 = p + (R * 1.000);
double R22 = p + (R * 0.618);
double R11 = p + (R * 0.382);
double S11 = p - (R * 0.382);
double S22 = p - (R * 0.618);
double S33 = p - (R * 1.000);
double S44 = p - (R * 1.618);

drawLine(R44,"R44", Pink,0);
drawLabel("R+1.618",R33,Pink);
drawLine(R33,"R33", Pink,0);
drawLabel("R+1.000",R33,Pink);
drawLine(R22,"R22", Pink,0);
drawLabel("R+0.618",R22,Pink);
drawLine(R11,"R11", Pink,0);
drawLabel("R+0.382",R11,Pink);

drawLine(p,"PIVOT1",Pink,1);
drawLabel("H4 Pivot1",p,Pink);

drawLine(S11,"S11",Pink,0);
drawLabel("S-0.382",S11,Pink);
drawLine(S22,"S22",Pink,0);
drawLabel("S-0.618",S22,Pink);
drawLine(S33,"S33",Pink,0);
drawLabel("S-1.000",S33,Pink);
drawLine(S44,"S44", Pink,0);
drawLabel("S-1.618",S44,Pink);

//----
   return(0);
  }
//+------------------------------------------------------------------+
void drawLabel(string name,double lvl,color Color)
{
    if(ObjectFind(name) != 0)
    {
        ObjectCreate(name, OBJ_TEXT, 0, Time[10], lvl);
        ObjectSetText(name, name, 8, "Courier", EMPTY);
        ObjectSet(name, OBJPROP_COLOR, Color);
    }
    else
    {
        ObjectMove(name, 0, Time[10], lvl);
    }
}


void drawLine(double lvl,string name, color Col,int type)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,1);
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,1);
          
         }
}